<html>
   <head>
      <meta http-equiv="pragma"        content="no-cache">
      <meta http-equiv='content-type'  content='text/html; charset=utf-8'>
      <title>%value $host% - Package Home</title>
      %invoke wia.test.issprofiler.overheadbenchmark.ui.util:getStyleMetadata%
      <link rel="stylesheet" type="text/css" href="%value WmRoot/cssFilename%">
      <link rel="stylesheet" type="text/css" href="package.css">
      <link rel="stylesheet" type="text/css" href="/WiaRoot/css/onlinedoc.css">
      <script type="text/javascript" src="%value WmRoot/jsFilename%"></script>
      %end invoke%
      <style>
         <!--
         h2 { border: 0; }

         h2 tt
            {
            font-size: 130%;
            }
         -->
      </style>
   </head>

   <body>

      <table>
         <tr>
            <td width="10"></td>
            <td>

               <table border="0" VALIGN="top">
                  <td valign="top">
                    <a href="ovhdbnchmk_starter.dsp"> Goto Overhead Benchmarking </a>
                  </td>
                  <tr>
                     <td align="right"><img src="/WiaRoot/images/logo.gif"></td>
                  </tr>
                  <tr>
                     <td colspan="2">
                        <p class="toptitle">
                          Wrightia Service Profiler Overhead Benchmarking
                        </p>

                        <h2>Package <tt>WiaServiceProfiler_OvhBnchmk</tt></h2>
                           <div>
                              <p>
                                 This package contains functionality that allows having an idea of the overhead the
                                 <span class="productname">Service Profiler</span>
                                 can add to service invocations when activated, on the system it is installed.
                              </p>
                              <p>
                                 This functionality can be run directly from this package's <span class="systemname">DSP</span>s.
                              </p>
                           </div>

                        <h2>Pre-requisites</h2>
                           <div>
                              <p>
                                 Installed packages:
                                 <ul>
                                    <li>You must have the <span class="productname">Service Profiler</span> correctly installed;</li>
                                    <li>You must have all the packages listed as part the installation of the <span class="systemname">Overhead Benchmarking</span>;
                                       <br>These packages are the all the listed as dependencies of the current one.
                                    </li>
                                    <li>System availability.
                                       <br>Please read further.
                                    </li>
                                 </ul>
                              </p>
                           </div>

                        <h2>System Availability</h2>
                           <div>
                              <p>
                                 The <span class="systemname">Overhead Benchmarking</span> process will intensively run a
                                 batery of services, activating and deactivating the <span class="productname">Service Profiler</span>
                                 during the process.
                              </p>
                              <p>
                                 At the end, the collected results are processed and a report summary is produced.
                              </p>
                              <p>
                                 During this process, the <span class="productname">CPU</span> is highly requested, being very
                                 normal to be constantly at 100% for a few minutes... the default processing will execute
                                 over 9 million service invocations.
                              </p>
                              <p>
                                 Because the process is highly dependent of comparing elapsed times, it is best to not have other
                                 processes running during the <span class="systemname">Overhead Benchmarking</span> process.
                                 Anyway, because the <span class="systemname">Overhead Benchmarking</span> process is very <span class="productname">CPU</span>
                                 intensive, any other process running at the same time will be deeply affected.
                              </p>
                           </div>

                        <h2>How the test is done</h2>
                           <div>
                              <p>
                                 The process runs a set of <span class="productname">Use Cases</span> with the
                                 <span class="productname">Service Profiler</span> inactive and the exact same set with the
                                 tool activated. For each set it collects their elapsed times. At the end it compares those times,
                                 adds a cross-referenced analysis from a snapshot taken on the run with the tool activated, and
                                 produces a summary report.
                              </p>
                              <p>
                                 The <span class="productname">Service Profiler</span> does no work while a service is running
                                 and only adds any overhead on its invocation and return.
                                 <br>
                                 Due to this feature, and to be minimally accurate, the services that are being used for the analysis contain no
                                 functionality themselves, or contain very basic functionality: such as calling a <tt>pub:math:addInts</tt>.
                                 <br>
                                 To increase the accurracy of the average count, these services have to be called many times.
                                 As stated above, <u>the default processing will execute over 9 million service invocations</u>.

                              </p>
                           </div>

                        <h2>Overhead Benchmarking Result Antecipation</h2>
                           <div>
                              <p>
                                 On tests already run on several systems, the overhead steadly measured between 10% and 20% of
                                 the elapsed time. Because the services are doing no real work, this overhead is almost exclusively
                                 being measured on the invocation mecanism.
                              </p>
                              <p>
                                 The measured percentage translates into overheads in the magniture of 5 to 15 microseconds
                                 per service invocation.
                                 <br>
                                 In absolute terms, it can viewed like this: assuming an average overhead of 20 microseconds
                                 per service invocation, after 1 million calls, 20 seconds have been added to the server
                                 overall execution time.
                              </p>
                              <p>
                                 However, and by all means, you should the <a href="ovhdbnchmk_starter.dsp">test it</a>
                                 on you own <span class="productname">Integration Server</span>.
                              </p>
                           </div>

                        <h2>Service Profiler Memory Footprint</h2>
                           <div>
                              <p>
                                 The <span class="productname">Service Profiler</span> consists of one
                                 <span class="productname">Integration Server Package</span> plus two additional ones for
                                 support and general usage utilities.
                                 <br>
                                 The addition of these three new packages is not noticeable on the overall server used memory.
                              </p>
                              <p>
                                 While running activated, the tool will create a structure to hold the collected data.
                                 This structure, for a <i>considered-very-large</i> count of 3000 invocation nodes will take less
                                 than 500 Kbytes.
                                 <br>
                                 Considering an anomalous situation where no released memory is garbage collected, at
                                 extreme cases this data structure can be copied up to four times. Under these extreme
                                 conditions the total amount of memory used by the profiler is roughly 2 Mbytes.
                              </p>

                           </div>

                     </td>
                  </tr>
               </table>

            </td>
         </tr>
      </table>

   </body>
</html>
